/* include gnu.gpl, (*) 2000 Micha 'malekith' Moskal <malekith@topnet.pl>. 
 * $Id: init.c,v 1.6 2000/08/27 18:32:51 malekith Exp $ */

#include "bot.h"
#include "script_ext.h"
#include "var.h"

#include <signal.h>
#include <unistd.h>

void irc_init();
void win_init();
void init_listen();
void init_input();
void init_scripting_engine();

static void sig_ign(int s)
{
	signal(s, sig_ign);
}

static void sod(int s)
{
	prtf(0, "cought deadly signal %d ... exiting ...", s);
	sleep(1);
	quit();
}

void init_signals()
{
	/* this shall work under bsd&sysv sementics */
	signal(SIGALRM, sig_ign);
	signal(SIGHUP, sig_ign);
	signal(SIGPIPE, sig_ign);
	
	signal(SIGINT, sod);
	signal(SIGTERM, sod);
}

static void init_script()
{
	char dir[1024];
	char *f;

	getcwd(dir, 1000);
	init_home_dir();
	chdir(dir);

	set_sv(sv("data_dir"), DATADIR);
	set_sv(sv("home_dir"), home_dir);

	f = xf("%s/s/main", home_dir);
	if (access(f, R_OK)) {
		xfree(f);
		f = xstrdup(DATADIR "/s/main");
		if (access(f, R_OK)) {
			xfree(f);
			f = 0;
		}
	}
	
	if (f == 0)
		prtf(0, "!!! couldn't found any usable script! checked: "
			"%s/s/main and %s/s/main", home_dir, DATADIR);
	else
		load_file(f);
	xfree(f);
}

void init()
{
	win_init();
	init_signals();
	init_scripting_engine();
prt(0, "init irc ...");
	irc_init();
prt(0, "init input ...");
	init_input();
prt(0, "init load script ...");
	init_script();
prt(0, "init listen socket ...");
	init_listen();
prt(0, "init complate.");
}

