/* include gnu.gpl, (*) 2000 Micha 'malekith' Moskal <malekith@topnet.pl>. 
 * $Id: magic.c,v 1.4 2000/08/02 15:22:58 malekith Exp $ */

#include "vm.h"

struct magic {
	char *name;
	var *(*exec)(vm_token *t, frame *f);
};

static var *m_void(vm_token *t, frame *f)
{
	(void)t;
	(void)f;
	return 0;
}

static var *m_file(vm_token *t, frame *f)
{
	(void)f;
	return new_sv(0, input_file_name(t));
}

static var *m_line(vm_token *t, frame *f)
{
	(void)f;
	return new_iv(0, t->line);
}

extern char *xversion, *xdate;

static var *m_xver(vm_token *t, frame *f)
{
	(void)f;
	(void)t;
	return new_iv(0, 20000731);
}

static var *m_version(vm_token *t, frame *f)
{
	char *p;
	var *v;
	
	(void)f;
	(void)t;

	p = xf("schiza %s [%s]", xversion, xdate);
	v = new_sv(0, p);
	xfree(p);

	return v;
}


static struct magic m[] = {
	{ "FILE", m_file },
	{ "LINE", m_line },
	{ "VOID", m_void },
	{ "XVER", m_xver },
	{ "VERSION", m_version },
	{ 0, 0 }
};

var *get_magic_var(vm_token * t, frame * f)
{
	struct magic *p;
	char *n = t->u.name + 1;
	
	if (*n == 0)
		return 0;
		
	while (isdigit(*n))
		n++;
		
	if (*n == 0)
		return regexp_get(t, f, atoi(t->u.name + 1));
		
	for (n = t->u.name + 1, p = m; p->name; p++) 
		if (strcmp(n, p->name) == 0)
			break;
			
	if (p->name)
		return p->exec(t, f);
	else 
		return 0;
}
